#ifndef _defs_h_included_
#define _defs_h_included_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utils.h"

#define TRUE 1
#define FALSE 0
#define SUCCEEDED 0
#define FAILED -1

#define maxOpNum 64
#define bitNum 32
#define maxRegNum 128
#define maxLabelNum 1024
#define maxFloatNum 1024

char* source;
char* dest ;
char* opcode_file;
char* register_file;
int opNum, regNum, labelNum, constFloatNum, neglectNum;
int TOTAL_INSTRUCTIONS_NUM, TOTAL_LABELS_NUM, TOTAL_CONST_FLOAT_NUM;

extern int parse(char input[], char *arg[]);

char *signExtend(char *str, int len);	
int saveConstFloats(char *FLOAT_TABLE[], char *constValue, int valueLen);
int saveLabels(char *labelName, int lineNum, char **label[], int option);
int getLabels(int lineNum, char *cmdLine[], char **op[], char **label[], char *FLOAT_TABLE[]);
int countInstructions(int lineNum, char *cmdLine[], char **op[]);
int assemble(int lineNum, char *cmdLine[], int cmdLength, char **op[], char **reg[], char **label[], FILE *fd);

void printFloatTable(char *FLOAT_TABLE[], FILE* fd);

#endif
